#pragma once

#include <atlstr.h>
#include<string>
#include "WTextFile.h"
#include "InputError.h"

using namespace std;


class SubCondition :
	public CObject
{
public:
	DECLARE_SERIAL( SubCondition )

	SubCondition(){};
	SubCondition(int col, int comp, double refValue);
	SubCondition(int col, int comp, CString refValueText);
	SubCondition(SubCondition *copySubCondition);
	~SubCondition(void);

public:
	int column;

	// 0: =
	// -1: <=
	// -2: <
	// 1: >=
	// 2: >
	// 10: NOT
	int comparator;
	double referenceValue;

	// 0: constant
	// 1: column #
	int referenceType;

	CString referenceValueText;
	BOOL textRef;
	// A normal SubCondition consists of 1 condition,
	// an OrSubCondition of an arbitrary number
	int size;
	BOOL orType;

	void changeValues(int col, int comp, double refValue, int refType);
	void changeValues(int col, int comp, CString refValueText, int refType);
	virtual BOOL check(WTextFile *theTextFile, int lineNumber);
	void setTextRef(BOOL text);

	virtual void Serialize( CArchive& archive );
	virtual InputError checkValidInputs( WTextFile * theTextFile );
};
